/**
 * The pretty simple algorithm translating morse code into text.
 * 
 */
public class Translator 
{
    private Tuple[] alphabet = { new Tuple(".-", "a"),new Tuple("-...", "b"),new Tuple("-.-.", "c"),new Tuple("-..", "d"),new Tuple(".", "e"),new Tuple("..-.", "f"),new Tuple("--.", "g"),new Tuple("....", "h"),new Tuple("..", "i"),new Tuple(".---", "j"),new Tuple("-.-", "k"),new Tuple(".-..", "l"),new Tuple("--", "m"),new Tuple("-.", "n"),new Tuple("---", "o"),new Tuple(".--.", "p"),new Tuple("--.-", "q"),new Tuple(".-.", "r"),new Tuple("...", "s"),new Tuple("-", "t"),new Tuple("..-", "u"),new Tuple("...-", "v"),new Tuple(".--", "w"),new Tuple("-..-", "x"),new Tuple("-.--", "y"),new Tuple("--..", "z"),new Tuple("-----", "0"),new Tuple(".----", "1"),new Tuple("..---", "2"),new Tuple("...--", "3"),new Tuple("....-", "4"),new Tuple(".....", "5"),new Tuple("-....", "6"),new Tuple("--...", "7"),new Tuple("---..", "8"),new Tuple("----.", "9"),new Tuple(".-.-", "ä"),new Tuple("---.", "ö"),new Tuple("..--", "ü"),new Tuple("...--..", "ß"),new Tuple(".-.-.-", "."),new Tuple("--..--", ","),new Tuple("---...", ":"),new Tuple("-.-.-.", ";"),new Tuple("..--..", "?"),new Tuple("-....-", "-"),new Tuple("..--.-", "_"),new Tuple("-.--.", "("),new Tuple("-.--.-", ")"),new Tuple(".----.", "'"),new Tuple("-...-", "="),new Tuple(".-.-.", "+"),new Tuple("-..-.", "#"),new Tuple(".--.-.", "@"),new Tuple("...---...", "SOS") };
    
    public Translator() {
            
    }
    
    public String decrypt(String message) {
        String[] c = message.split(" ");
        String d = "";
        for(int i=0; i<c.length; i++) {
            if(c[i].equals("/") || c[i].equals("#")) {
                d += " ";
            }
            else {
                for(int k=0; k<alphabet.length; k++) {
                    if(c[i].equals(alphabet[k].a())) {
                        d += alphabet[k].b();
                    }
                }
            }
        }
        return d;
    }
    public String encrypt(String message) {
        String[] c = message.split(" ");
        String e = "";
        for(int i=0; i<c.length; i++) {
            char[] word = c[i].toCharArray();
            for(int k=0; k<word.length; k++) {
                String ch = "" + word[k];
                for(int l=0; l<alphabet.length; l++) {
                    if(ch.equals(alphabet[l].b())) {
                        e += alphabet[l].a();
                        e += " ";
                    }
                }
            }
            if(i < c.length-1) {
                e += "/ ";
            }
        }
        return e;
    }
}
